#---------------------------------------------------------
# This Datapack was made by CommandGeek
# Please do not copy or credit this as your own work!
# Youtube: www.youtube.com/CommandGeek
#---------------------------------------------------------

effect give @e[tag=cookie_wolf] minecraft:speed 1000000 1 true

# Spawn Egg
execute at @e[tag=spawn_cookie] run function cookie:spawn_cookie
kill @e[tag=spawn_cookie]

# Teleporting
execute at @e[tag=cookie_wolf,tag=moving] rotated ~ 0 as @e[tag=cookie_legs] if score @s CookieID = @e[tag=cookie_wolf,distance=0,limit=1] CookieID run tp @s ^ ^-.61 ^
execute at @e[tag=cookie_wolf,tag=moving] rotated ~ 0 as @e[tag=cookie_arms] if score @s CookieID = @e[tag=cookie_wolf,distance=0,limit=1] CookieID run tp @s ^ ^ ^


    
# Rotaiton
execute at @e[tag=cookie_wolf] as @e[tag=cookie,tag=!cookie_wolf] if score @s CookieID = @e[tag=cookie_wolf,distance=0,limit=1] CookieID run data modify entity @s Rotation[0] set from entity @e[tag=cookie_wolf,distance=..0.1,limit=1] Rotation[0]
    
# Detect Movement
execute as @e[tag=cookie_wolf] store result score @s CookieMotionX run data get entity @s Motion[0] 1000
execute as @e[tag=cookie_wolf] store result score @s CookieMotionZ run data get entity @s Motion[2] 1000
tag @e[tag=cookie_wolf] add moving
tag @e[tag=cookie_wolf,scores={CookieMotionX=0,CookieMotionZ=0}] remove moving
scoreboard players set @e[tag=cookie_wolf,tag=!moving] CookieWalking 0

scoreboard players add @e[tag=cookie_wolf,tag=moving,scores={CookieWalk=1}] CookieWalking 1
scoreboard players remove @e[tag=cookie_wolf,tag=moving,scores={CookieWalk=0}] CookieWalking 1

scoreboard players set @e[tag=cookie_wolf,scores={CookieWalking=..-5}] CookieWalk 1
scoreboard players set @e[tag=cookie_wolf,scores={CookieWalking=5..}] CookieWalk 0

# execute as @e[tag=cookie_wolf,tag=!moving] at @s run tp @s ~ ~ ~ facing entity @p[distance=..5]

# Animation
execute at @e[tag=cookie_wolf] as @e[tag=cookie_legs] if score @s CookieID = @e[tag=cookie_wolf,distance=0,limit=1] CookieID store result entity @s Pose.RightArm[0] float 10 run scoreboard players get @e[tag=cookie_wolf,limit=1,distance=0] CookieWalking
execute at @e[tag=cookie_wolf] as @e[tag=cookie_legs] if score @s CookieID = @e[tag=cookie_wolf,distance=0,limit=1] CookieID store result entity @s Pose.LeftArm[0] float -10 run scoreboard players get @e[tag=cookie_wolf,limit=1,distance=0] CookieWalking
    
execute at @e[tag=cookie_wolf] as @e[tag=cookie_arms] if score @s CookieID = @e[tag=cookie_wolf,distance=0,limit=1] CookieID store result entity @s Pose.RightArm[0] float -10 run scoreboard players get @e[tag=cookie_wolf,limit=1,distance=0] CookieWalking
execute at @e[tag=cookie_wolf] as @e[tag=cookie_arms] if score @s CookieID = @e[tag=cookie_wolf,distance=0,limit=1] CookieID store result entity @s Pose.LeftArm[0] float 10 run scoreboard players get @e[tag=cookie_wolf,limit=1,distance=0] CookieWalking

    
    

# Models
execute as @e[tag=cookie_wolf] unless data entity @s CustomName run data modify entity @s CustomName set value "\"Cookie\""

execute at @e[tag=cookie_wolf,scores={CookieDamage=0}] as @e[tag=cookie_arms,nbt=!{ArmorItems:[{},{},{},{tag:{CustomModelData:1}}]}] if score @s CookieID = @e[tag=cookie_wolf,limit=1,sort=nearest] CookieID run data modify entity @s ArmorItems[3] set value {id:"yellow_dye",Count:1b,tag:{CustomModelData:1}}
    
execute as @e[tag=cookie_wolf,scores={CookieDamage=0}] if data entity @s AngryAt at @s as @e[tag=cookie_arms,nbt=!{ArmorItems:[{},{},{},{tag:{CustomModelData:7}}]}] if score @s CookieID = @e[tag=cookie_wolf,limit=1,sort=nearest] CookieID run data modify entity @s ArmorItems[3] set value {id:"yellow_dye",Count:1b,tag:{CustomModelData:7}}    
    
execute at @e[tag=cookie_wolf,scores={CookieDamage=0}] as @e[tag=cookie_legs,nbt=!{HandItems:[{id:"minecraft:yellow_dye",tag:{CustomModelData:2}},{id:"minecraft:yellow_dye",tag:{CustomModelData:2}}]}] if score @s CookieID = @e[tag=cookie_wolf,limit=1,sort=nearest] CookieID run data modify entity @s HandItems set value [{id:"yellow_dye",Count:1b,tag:{CustomModelData:2}},{id:"yellow_dye",Count:1b,tag:{CustomModelData:2}}]

execute at @e[tag=cookie_wolf,scores={CookieDamage=0}] as @e[tag=cookie_arms,nbt=!{HandItems:[{id:"minecraft:yellow_dye",tag:{CustomModelData:3}},{id:"minecraft:yellow_dye",tag:{CustomModelData:3}}]}] if score @s CookieID = @e[tag=cookie_wolf,limit=1,sort=nearest] CookieID run data modify entity @s HandItems set value [{id:"yellow_dye",Count:1b,tag:{CustomModelData:3}},{id:"yellow_dye",Count:1b,tag:{CustomModelData:3}}]

    
execute at @e[tag=cookie_wolf,scores={CookieDamage=1..}] as @e[tag=cookie_arms,nbt=!{ArmorItems:[{},{},{},{tag:{CustomModelData:4}}]}] if score @s CookieID = @e[tag=cookie_wolf,limit=1,sort=nearest] CookieID run data modify entity @s ArmorItems[3] set value {id:"yellow_dye",Count:1b,tag:{CustomModelData:4}}

execute as @e[tag=cookie_wolf,scores={CookieDamage=1..}] if data entity @s AngryAt at @s as @e[tag=cookie_arms,nbt=!{ArmorItems:[{},{},{},{tag:{CustomModelData:8}}]}] if score @s CookieID = @e[tag=cookie_wolf,limit=1,sort=nearest] CookieID run data modify entity @s ArmorItems[3] set value {id:"yellow_dye",Count:1b,tag:{CustomModelData:8}}    
    
execute at @e[tag=cookie_wolf,scores={CookieDamage=1..}] as @e[tag=cookie_legs,nbt=!{HandItems:[{id:"minecraft:yellow_dye",tag:{CustomModelData:5}},{id:"minecraft:yellow_dye",tag:{CustomModelData:5}}]}] if score @s CookieID = @e[tag=cookie_wolf,limit=1,sort=nearest] CookieID run data modify entity @s HandItems set value [{id:"yellow_dye",Count:1b,tag:{CustomModelData:5}},{id:"yellow_dye",Count:1b,tag:{CustomModelData:5}}]

execute at @e[tag=cookie_wolf,scores={CookieDamage=1..}] as @e[tag=cookie_arms,nbt=!{HandItems:[{id:"minecraft:yellow_dye",tag:{CustomModelData:6}},{id:"minecraft:yellow_dye",tag:{CustomModelData:6}}]}] if score @s CookieID = @e[tag=cookie_wolf,limit=1,sort=nearest] CookieID run data modify entity @s HandItems set value [{id:"yellow_dye",Count:1b,tag:{CustomModelData:6}},{id:"yellow_dye",Count:1b,tag:{CustomModelData:6}}]


# Cookie Spawning

execute as @e[type=squid,tag=!tagged,predicate=cookie:river] if predicate cookie:spawn at @s run function cookie:river_spawn_cookie
tag @e[type=squid,tag=!tagged] add tagged

# Cookie Damage

execute as @e[tag=cookie_wolf] store result score @s CookieHealth1 run data get entity @s Health 10
execute as @e[tag=cookie_wolf] unless score @s CookieHealth1 = @s CookieHealth2 run scoreboard players set @s CookieDamage 10
execute at @e[tag=cookie_wolf,scores={CookieDamage=10}] run playsound minecraft:entity.player.burp neutral @a
execute at @e[tag=cookie_wolf,scores={CookieDamage=10}] run playsound minecraft:entity.generic.eat neutral @a
execute as @e[tag=cookie_wolf] store result score @s CookieHealth2 run data get entity @s Health 10
scoreboard players remove @e[tag=cookie_wolf,scores={CookieDamage=1..}] CookieDamage 1

# Taming

execute as @e[tag=cookie_wolf] at @s if entity @e[type=item,nbt={Item:{id:"minecraft:milk_bucket"}},distance=..2] run function cookie:cookie_eat

# Killing

execute at @e[tag=cookie_wolf] as @e[tag=cookie,tag=!cookie_wolf] if score @s CookieID = @e[tag=cookie_wolf,distance=0,limit=1] CookieID run tag @s add cookie_live
execute as @e[tag=cookie,tag=!cookie_live,tag=!cookie_wolf] at @s run function cookie:kill
kill @e[tag=cookie,tag=!cookie_live,tag=!cookie_wolf]
tag @e[tag=cookie_live] remove cookie_live

# Angry

execute as @e[tag=cookie_wolf] unless data entity @s Owner unless data entity @s AngryAt at @s run data modify entity @s AngryAt set from entity @p UUID











